<?php
/**
 * @version		$Id: jacategories.php 1.0.0 2008-05-20 04:35:10Z instance $
 * @package		Joomla
 * @subpackage	Jashowcase
 * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * @author      Joomlart.com
 */
// no direct access
defined('_JEXEC') or die('Restricted access');


class JashowcaseControllerJacategories extends JashowcaseController
{
	/**
	 * Constructor
	 */
	function __construct( $default = array())
	{
		parent::__construct( $default );
		$this->registerTask( 'apply', 		'save');
		$this->registerTask( 'unpublish', 	'publish');
	}

	/**
	 * Display
	 */
	function display()
	{		
		switch($this->getTask())
		{						
			case 'add':
			{
				JRequest::setVar( 'hidemainmenu', 1 );
				JRequest::setVar( 'layout', 'form'  );
				JRequest::setVar( 'edit', false  );
			} break;	
					
			case 'edit'    :
			{
				JRequest::setVar( 'layout', 'form'  );
				JRequest::setVar( 'hidemainmenu', 1 );
				JRequest::setVar( 'edit', true  );
			} break;				
		}			
		JRequest::setVar('view', 'jacategories');
		parent::display();
		
	}
	
	/**
	 * 
	 * @return redirect to categories
	 **/
	function cancel(){
		global $option;
		$this->setRedirect("index.php?option=$option&task=categories&controller=jacategories");
	}
	
	/**
	 * publish or unpublish list category
	 * @return void
	 **/
	function publish(){
		global  $option;
		if($this->getTask()=='unpublish'){
			$publish = 0;
		}
		else{
			$publish = 1;
		}
		
		$model = $this->getModel('jacategories');
				
		if (!$model->dopublish($publish)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
			exit();
		}
		$cache = & JFactory::getCache('com_jashowcase');
		$cache->clean();	
		$this->setRedirect('index.php?option='. $option .'&task=categories&controller=jacategories' , "Update successfull");
	}		
	
	/**
	 * delate category 
	 * @return void
	 **/
	function remove(){
		global $option;		
		$model = $this->getModel('jacategories');
		
		$cid = JRequest::getVar('cid', 0);
		if(!is_array($cid)){
		  $cid = array($cid);
		}	    
		
		for($i=0,$n=count($cid);$i<$n;$i++){
			  $id = $cid[$i];
			  
			  $total = $model->_getTotalCategories();
			  
			  if($total > 0){
					echo "<script> alert('".JText::_('THERE IS SUB CATEGORY')."'); window.history.go(-1); </script>\n";
					return ;
			  }
			  			  
			  $total = $model->_getTotalShowcase();
			  if($total > 0){
					echo "<script> alert('This categories ".$id." is not empty.'); window.history.go(-1); </script>\n";
					return;
			  }
	
			  if(!$model->delete($id)) {
				echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
			  }
		}
		$cache = & JFactory::getCache('com_jashowcase');
		$cache->clean();
	
		$this->setRedirect('index.php?option=' . $option . '&task=categories&controller=jacategories', count($cid)." deleted");
	}
	
	
	/**
	 * save category 
	 * @return void
	 **/
	function save(){
		global $option, $mainframe;
		$cache = & JFactory::getCache('com_jashowcase');
		$cache->clean();		
		$model	=& $this->getModel( 'jacategories' );
		
		$post	= JRequest::get('post');
		// allow name only to contain html
		$post['name'] = JRequest::getVar( 'name', '', 'post', 'string', JREQUEST_ALLOWHTML );
		
		if(!$post['alias']){
			$post['alias'] = $post['title'];
		}
		$post['alias'] = strtolower($post['alias']);
		
		if($post['alias']!=''){			
			$alias = str_replace(' ', '-', $post['alias']);
			$post['alias'] = JRequest::setVar('alias', $alias);
			$id = JRequest::getVar('id', 0);
			$db = &JFactory::getDBO();
			$sql = "SELECT * FROM #__categories WHERE alias='".$alias."' ";
			if($id!=0) {
				$sql .= " and id!=$id";
			}
			$db->setQuery($sql);
			$total = $db->loadObject();			
			if($total){
				echo "<script> alert('This alias really exit!'); window.history.go(-1);</script>\n";
				exit;
				$mainframe->redirect('index.php?option=' . $option . '&task=editcategory&controller=jacategories&cid=' .$id . '&hidemainmenu=1',  'This alias really exit!');
			}
		}
		
		$model->setState( 'request', $post );
		
		if ($cid = $model->store()) {
			$msg = JText::_( 'Category Saved' );
		} else {
			$msg = JText::_( 'Error Saving Category' );
		}
		
		switch ($this->getTask()){		 
		  case 'apply':
			$this->setRedirect('index.php?option=' . $option . '&task=edit&controller=jacategories&cid=' .$cid . '&hidemainmenu=1',  $msg);
			break;
		  default :
			$this->setRedirect('index.php?option=' . $option . '&task=categories&controller=jacategories', $msg);
			break;
		}
	}
		/**
	 * save order categories
	 * @return void
	 **/
	function saveorderCat(){
		global $mainframe, $option;
		$model	=& $this->getModel( 'jacategories' );	
		if(!$model->order()){
			return false;
		}
		$mainframe->redirect( 'index.php?option='. $option."&task=categories&controller=jacategories" , "New ordering saved");
	}
	
}
?>