<?php
/**
* @version		$Id: weblink.php 10079 2008-02-28 13:39:08Z ircmaxell $
* @package		Joomla
* @subpackage	JaShowcase
* @copyright	Copyright (C) 2005 - 2008 Joomlart.com. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

/**
* Jacategories Table class
*
* @package		Joomla
* @subpackage	Jashowcase
* @since 1.0
*/
class TableJacategories extends JTable
{
	/**
	 * Primary Key
	 *
	 * @var int
	 */
	var $id = 0;
	var $title = null;
	var $parent_id = null;
	var $name			= null;
	var $alias			= null;
	var $image 	= null;
	var $section 		= 0;
	var $image_position   	= null;
	var $description  		= null;
	var $published  		= null;
	var $checked_out 		= null;
	var $checked_out_time 		= null;
	var $editor 		= null;
	var $ordering 		= null;
	var $access 		= null;
	var $count 		= null;
	var $params 		= null;

	/**
	 * Constructor
	 *
	 * @param object Database connector object
	 * @since 1.0
	 */
	function __construct(& $db) {
		parent::__construct('#__categories', 'id', $db);
	}

	/**
	* Overloaded bind function
	*
	* @acces public
	* @param array $hash named array
	* @return null|string	null is operation was satisfactory, otherwise returns an error
	* @see JTable:bind
	* @since 1.5
	*/
	function bind($array, $ignore = '')
	{
		if (key_exists( 'params', $array ) && is_array( $array['params'] ))
		{
			$registry = new JRegistry();
			$registry->loadArray($array['params']);
			$array['params'] = $registry->toString();
		}

		return parent::bind($array, $ignore);
	}
	
}
