<?php
/**
 * Jacategories View for Jashowcase Component
 * 
 * @package    	Joomla.Jashowcase
 * @subpackage 	Components
 * @link 		http://joomlart.com/extension/
 * @license		Joomlart.com
 * @author 		Joomlart.com
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

/**
 * Jacategories View
 *
 * @package    Joomla.Jashowcase
 * @subpackage Components
 */
class jashowcaseViewjacategories extends JView
{
	
	/**
	 * display method of jacategories view
	 * @return void
	 **/
	function display($tpl = null)
	{		
		$task = JRequest::getVar("task", '');
		switch ($task){
			case 'add':
			case 'edit':
				jashowcaseViewjacategories::displayForm($tpl);
				break;
			default:
				jashowcaseViewjacategories::displayListCategories($tpl);
		}								
	}
	
	/**
	 * display list categories, template default
	 * @return void
	 **/
	function displayListCategories($tpl){
		global $mainframe, $option;		
		$db = &JFactory::getDBO();
		
		if(!isset($_REQUEST['filter_order_1']) && !isset($_REQUEST['filter_order_Dir_1'])){
			
		}
		$context = $option.'.jacategories.list.';
		
		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest( $context.'limitstart', 'limitstart', 0, 'int' );

		$filter_order		= 	$mainframe->getUserStateFromRequest( $context.'order_1',	'order_1',		'c.ordering',	'cmd' );				
		$filter_order_Dir	= 	$mainframe->getUserStateFromRequest( $context.'order_Dir_1', 'order_Dir_1',	'',				'word' );
		
		$search				= 	$mainframe->getUserStateFromRequest( $option.".search", 'search', '' );
		$search				= 	$db->getEscaped( trim( strtolower( $search ) ) );
		
		$where = array();
		$where[] = "c.section = 'com_jashowcase'";
		if(!empty($search)){
		  $where[] = "c.title LIKE '%" . $search . "%'";
		}
		$orderbyTotalshow = '';
		$where		= count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '';
		$orderby	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', c.ordering';
		
		$query = "SELECT COUNT(1) FROM #__categories c "
				.$where;
		
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination( $total, $limitstart, $limit );
		
		$query = "SELECT c.* FROM #__categories c "
				.$where
				.$orderby;//print_r($query);exit;
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		if ($db->getErrorNum())
		{
			echo $db->stderr();
			return false;
		}
		
		$level = 0;
		$tree = array();
		$totalShow = array();
	
		for($i=0,$n=count($rows);$i<$n;$i++){
		  	$row = $rows[$i];
			$query = "SELECT COUNT(1) FROM #__jashowcase WHERE catid=".$row->id;
			$db->setQuery($query);
			$totalShow[] = $db->loadResult();		  
		  	$tree[$row->parent_id][] = $row;
		}		
		
		$final = array();
		$level = 0;
	
		if(isset($tree[0]) && count($tree[0]) > 0){
		  for($i=0,$n=count($tree[0]);$i<$n;$i++){
			$row = $tree[0][$i];
			jashowcaseViewjacategories::recurseCategorie($tree, $final, $row, $level);
		  }
		}
		$final = array_slice($final, $limitstart, $limit);
		
		$lists['search'] = $search;
		$lists['order_Dir_1']	= $filter_order_Dir;
		$lists['order_1']		= $filter_order;
		
		$task = isset($_REQUEST['task'])?$_REQUEST['task']:'';
		
		$this->assignRef('rows', $final);
		$this->assignRef('pageNav', $pagination);
		$this->assignRef('lists', $lists);
		$this->assignRef('totalShow', $totalShow);		
		$this->assignRef('task', $task);
		
		parent::display($tpl);
	}
	
	/**
	 * display form edit, template form
	 * @return void
	 **/
	function displayForm($tpl){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		$cid 	= JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger($cid, array(0));
		$edit		= JRequest::getVar('edit',true);
		
		$lists 	= array();
		$row = array();
		$row =& $this->get('Data');
		
		$categories = jashowcaseViewjacategories::getCategorieTree();
		
		$obj = new stdClass();
		$obj->id = 0;
		$obj->name = 'Top';
		array_unshift($categories, $obj);
		
		$parent_id =  isset($row->parent_id)?$row->parent_id:null ;
		$lists = array();
		$lists['parent_id'] = JHTML::_( 'select.genericlist', $categories, 'parent_id', 'class="inputbox" size="1"', 'id', 'name', $parent_id);
		$lists['published'] = JHTML::_('select.booleanlist',  'published', '', isset($row->published)?intval($row->published):'');
		$lists['access'] 	= JHTML::_('list.accesslevel', $row);

		$this->assignRef('lists', $lists);
		$this->assignRef('row', $row);

		parent::display($tpl);	
	}
	
	function getCategorieTree($published_only = false){
		global $mainframe;
		$db		=& JFactory::getDBO();
		
		$query = "SELECT * FROM #__categories WHERE section = 'com_ja_showcase' ";
		if($published_only){
		  $query .= "AND published = 1 ";
		}
		$query .= "ORDER BY parent_id, name";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		
		echo $db->getErrorMsg();
		
		$level = 0;
		$tree = array();
		//sort by parent
		for($i=0,$n=count($rows);$i<$n;$i++){
		  $row = $rows[$i];
		  
		  $tree[$row->parent_id][] = $row;
		}
		
		$final = array();
		$level = 0;
		//loop through all items
		if(isset($tree[0]) && count($tree[0]) > 0){
		  for($i=0,$n=count($tree[0]);$i<$n;$i++){
			$row = $tree[0][$i];
			$this->recurseCategorie($tree, $final, $row, $level);
		  }
		}
		return $final;
	}
	function recurseCategorie($rows, &$tree, $row, $level){
	
		$name = '';
		for($i=0;$i<$level;$i++){
		  $name .= '--';
		}
		if($level != 0){
		  $name = '|' . $name;
		}
		$row->name = $name . ' ' . $row->name;
		
		$tree[] = $row;
		if(@sizeof($rows[$row->id])){
		  for($i=0,$n=count($rows[$row->id]);$i<$n;$i++){        
			$child = $rows[$row->id][$i];        
			$this->recurseCategorie($rows, $tree, $child, $level + 1);  
		  }
		}
	}
}
