<?php
/**
 * Jashowcase View for Jashowcase Component
 * 
 * @package    Jashowcase
 * @subpackage Components
 * @link http://joomlart.com/extemsion
 * @license		GNU/GPL
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );


class jashowcaseViewjashowcase extends JView
{
	/**
	 * display method of jashowcase view
	 * @return void
	 **/
	function display($tpl = null)
	{		
		global $mainframe;
		$path_thumbview = $mainframe->getSiteURL().JRequest::getVar('path_thumbview', '');		
		
		$task = JRequest::getVar("task", '');
		switch ($task){
			case 'add':
			case 'edit':				
				jashowcaseViewjashowcase::displayForm($tpl, $path_thumbview);
				break;
			
			case 'getfile':
				jashowcaseViewjashowcase::_getSelectFile();
				break;
				
			default:
				jashowcaseViewjashowcase::displayListItem($tpl, $path_thumbview);
		}								
	}
	
	/**
	 * display list item, template default
	 * @return void
	 **/
	function displayListItem($tpl, $path_thumbview){
		global $mainframe, $option;
		$db = &JFactory::getDBO();
		$model = $this->getModel('jashowcase');
		
    	$option_1 = $option.'.jashowcase';
		$search				= $mainframe->getUserStateFromRequest( "$option_1.search", 'search', 	'',	'string' );
		$search				= JString::strtolower($search );
		$filter_order		= $mainframe->getUserStateFromRequest( $option_1.'.filter_order',		'filter_order',		's.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option_1.'.filter_order_Dir',	'filter_order_Dir',	'',				'word' );
	
	    $limit				= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart			= $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );
				
	    $catSearch			= $mainframe->getUserStateFromRequest( $option.'.searchCat', 'searchCat', 0, 'int' );
		$ishoted			= $mainframe->getUserStateFromRequest( $option.'.ishoted', 'ishoted', 0, 'int' );
		
		$where = array();
		
	    if ($search) {
	        $where[] = " ((LOWER(s.name) LIKE '%$search%') or (s.id='$search') or (s.info_url LIKE '%$search%') or (s.demo_url LIKE '%$search%'))";
	    }
		if($catSearch){
			 $where[] = "catid = ".$catSearch;
		}
		if($ishoted!='0'){
			if($ishoted==2)  $where[] = "ishot = 0";
			else $where[] = "ishot = 1";
			
		}
		
		$where		= count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '';
		$orderby	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', s.ordering';
		
	    // get the total number of records
	    $query = "SELECT count(s.id) FROM #__jashowcase as s"
	    		.$where;
	    $db->setQuery($query);
	    $total = $db->loadResult();
		
	    if ($db->getErrorNum())
		{
			echo $db->stderr();
			return false;
		}
	
	    if ($limit > $total) {
	        $limitstart = 0;
	    }
	    if ($limit==0) {
	    	$limit = $total;
	    }
	    
	    jimport('joomla.html.pagination');
		$pagination = new JPagination( $total, $limitstart, $limit );
		
		$query = "SELECT s.*, c.name as categoriesName" . 
				"\nFROM #__jashowcase as s INNER JOIN #__categories c ON s.catid=c.id"
				.$where
				.$orderby
				." LIMIT ". $limitstart . ','. $limit;

		$db->setQuery($query);
		$items	=  $db->loadObjectList();

		if ($db->getErrorNum())
		{
			echo $db->stderr();
			return false;
		}
		
		$categories[] = JHTML::_('select.option',  '0', '- '. JText::_( 'SELECT CATEGORIES' , true) .' -' );
		$categories = array_merge($categories, $model->_getCategoriesJashowcase($db));
		
		if(!count($db->loadObjectList())){
			?>
			<script language="javascript" type="text/javascript">
			alert("You have to add a category first");
			</script>
			<?php	
		}
		$clist = JHTML::_( 'select.genericlist', $categories, 'searchCat', 'class="inputbox" size="1"','value', 'text', $catSearch );	
		
		//filter by ishot
		$ishostlist[] = JHTML::_('select.option',  0, '- '. JText::_( 'SELECT BY HOT') .' -' );
		$ishostlist[] = JHTML::_('select.option',  1, 'Yes' );
		$ishostlist[] = JHTML::_('select.option',  2, 'No' );
		$ishotlists   = JHTML::_('select.genericlist', $ishostlist, 'ishoted', 'class="inputbox" size="1"','value', 'text', $ishoted );	
		
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;
		$lists['search']	= $search;
		
		$this->assignRef('lists', $lists);
		$this->assignRef('ishotlists', $ishotlists);
		$this->assignRef('clist', $clist);
		$this->assignRef('items', $items);
		$this->assignRef('pageNav', $pagination);
		
		$this->assignRef('path_thumbview', $path_thumbview);
		
		parent::display($tpl);
	}	
	
	/**
	 * display form edit, template form
	 * @return void
	 **/
	function displayForm($tpl, $path_thumbview){
		global $option;	
		
		$this->_layout = 'form';
			
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();

		$cid 	= JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger($cid, array(0));
		$edit		= JRequest::getVar('edit',true);
		if($edit){
			$uid = 1;
		}
		else $uid = 0;
		$lists 	= array();

		$row =& $this->get('Data');

		$model = $this->getModel('jashowcase');
		$contents = $model->_getContents($db);
		$section = ''; $category = ''; $value = ''; $text = ''; 
		$temp[] = JHTML::_('select.option',  '', '---Select item for detail information---' );
		if ($contents) {
			foreach ( $contents as $content ) {
				$section = $model->_getTitleContent($content->sectionid, $db);
				$category = $model->_getTitleCategories($content->catid, $db); 
		
				$value = $content->value;
				$text = $section ." - ". $category ." / ". $content->text ."&nbsp;&nbsp;&nbsp;&nbsp;";
				$temp[] = JHTML::_('select.option',  $value, $text );
			}
		}		
		
		$static_contents = $model->_getStaticContents($db); 
		
		if ($static_contents) {
			foreach ( $static_contents as $static_content ) {
				$value = $static_content->value;
				$text =  $static_content->text ."&nbsp;&nbsp;&nbsp;&nbsp;";
				$temp[] = JHTML::_('select.option',  $value, $text );
			}
		}
		
		$contents = $temp; $lists['content'] = '';
		//	Create a list of links
		if ($contents) {
			$lists['content'] = JHTML::_( 'select.genericlist', $contents, 'info_url', 'class="inputbox" size="10"','value', 'text', $row->info_url  );	
		}	
		

		$lists['published'] = JHTML::_('select.booleanlist',  'published',  'class="inputbox"', $row->published ) ;
		$lists['ishoted'] 	= JHTML::_('select.booleanlist',  'ishot', 		'class="inputbox"', $row->ishot ) ;

		$query = "SELECT ordering AS value, name AS text"
					. "\n FROM #__jashowcase"
					. "\n ORDER BY ordering";
					
		$lists['ordering'] = JHTML::_('list.specificordering', $row, $uid, $query, 0 );
		$categories[] = JHTML::_('select.option', '0', "Select categories");
		
		$categoriesJashowcase 	= $model->_getCategoriesJashowcase($db);
		$categories 			= array_merge( $categories,  $categoriesJashowcase);
		$clist 					= JHTML::_('select.genericlist', $categories, 'catid', 'class="inputbox" size="1"', 'value', 'text', $row->catid);
		
		$file 			= JPATH_COMPONENT_ADMINISTRATOR.DS.'views/jaconfig/customfields.xml';
		$paramsFields 	= new JParameter($row->datas, $file);
		$row->datas 	= $paramsFields;
		
		//Get list of folder in showcase folder
		$head_path_thumb = JRequest::getVar('path_thumbview', '');

		if (JFolder::exists(JPATH_SITE.DS.$head_path_thumb)) {
			$tmpFolder	 		= $model->_getlistFolder(JPATH_SITE.DS.$head_path_thumb);
			$listFolder			= $tmpFolder;		
			$lists['listFolder'] = JHTML::_('select.genericlist', $listFolder, 'directory', 'class="inputbox" size="10"', 'value', 'text', $row->directory);
		}
		else{
			$lists['listFolder'] = '<select id="directory" class="inputbox" size="10" name="directory">
									</select>';
		}		
		
		//Get list of file in item folder	
		$choose_file[] 		= JHTML::_('select.option', '', "Select file");		
		$listFile 			= $model->_getlistFile(JPATH_SITE.DS.$head_path_thumb.DS.$row->directory);
		$listFile 			= array_merge( $choose_file,  $listFile);
		$lists['listFile'] = JHTML::_('select.genericlist', $listFile, 'thumbnail', 'class="inputbox" size="1" onchange="getSrcThumb();"', 'value', 'text', $row->thumbnail);
		
		$head_path_thumb = substr( $head_path_thumb, 7, strlen($head_path_thumb)-8);
		$this->assignRef('head_path_thumb', $head_path_thumb);
		$this->assignRef('lists', $lists);
		$this->assignRef('row', $row);
		
		/* Read customfields file*/	
		$this->assignRef('clist', $clist);
		$this->assignRef('task', $_REQUEST['task']);
		$this->assignRef('path_thumbview', $path_thumbview);
		$path_site = JRequest::getVar('path_thumbview', '');
		$this->assignRef('path_site', $path_site);
		
		
		parent::display($tpl);	
	}
	
	/*Get list of file in item folder*/
	function _getSelectFile(){
		$head_path_thumb = JRequest::getVar('path', '');
		$directory = JRequest::getVar('directory', '');
		
		$model = $this->getModel('jashowcase');
		
		$choose_file[] 		= JHTML::_('select.option', '', "Select file");		
		$listFile 			= $model->_getlistFile(JPATH_SITE.DS.$head_path_thumb.DS.$directory);
		$listFile 			= array_merge( $choose_file,  $listFile);
		echo JHTML::_('select.genericlist', $listFile, 'thumbnail', 'class="inputbox" size="1" onchange="getSrcThumb();"', 'value', 'text', '');	
	}
}
?>