<?php
/**
 * Jahowcase View for Jashowcase Component
 * 
 * @package    	Joomla
 * @subpackage 	Components
 * @link 		http://joomlart.com
 * @license		GNU/GPL
 * @author : 	joomlart.com
 */

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the jashowcase Component
 *
 * @package		Joomla
 * @subpackage	Components
 */
class JashowcaseViewJashowcase extends JView
{
	function display($tpl = null)
	{
		global $mainframe,$Itemid , $option;		
		require(JPATH_COMPONENT_ADMINISTRATOR."/controllers/jashowcase.php");
		
		$path_thumbview = JashowcaseControllerJashowcase::_getPathTthumbview(); 
		$paramsSetting  = JashowcaseControllerJashowcase::_getSetting(); 
		
		
		$db	=& JFactory::getDBO(); 
		$id	=  JRequest::getVar('id', 0); 
		
		$params 	   =& $mainframe->getParams('com_jashowcase');
		
		// Get the menu item object
		$menus = &JSite::getMenu();
		$menu  = $menus->getActive();
		
	    $limit = $params->get('cols')*$params->get('rows');
	    $limitstart = JRequest::getVar('limitstart', 0);
	 	$catid = JRequest::getVar('catid', 0);
	   
		$where = "";
		
		if($catid || $params->get('catid')){
			if(!$catid && $params->get('catid'))	$catid = $params->get('catid');
				$where .= " AND s.catid=".$catid;
		}
		
		// get the total number of records
		$query	= "SELECT count(*) FROM #__jashowcase as s INNER JOIN #__categories c ON s.catid=c.id and c.published=1 WHERE s.published=1 "
				  .$where;
				
	    $db->setQuery( $query );
	    $total = $db->loadResult();

	    echo $db->getErrorMsg();
	
	    if ($limit > $total) {
	        $limitstart = 0;
	    }
	    $queries = "SELECT s.*" 
	    			. "\nFROM #__jashowcase as s INNER JOIN #__categories c ON s.catid=c.id and c.published=1"
	    			."\nWHERE s.published=1"
	    			.$where
	    			." ORDER BY s.ordering ASC, s.id DESC "
	    			." LIMIT $limitstart,$limit";

	    $db->setQuery($queries);
	    $themes = $db->loadObjectList();
		
	    if ($db->getErrorNum()) {
	        echo $db->stderr();
	        return false;
	    }
	  
	    foreach ($themes as $k=>$item) {						
			$item->live_title = str_replace("[SHOWCASENAME]", $item->name, JText::_('TITLE_LIVE'));	
						
			$item->info_url_title = '';	 $item->demo_url_title = '';
			if ($item->info_url!='') {
				$item->info_url_title = $this->getPageTitle($item->info_url);
				$item->info_url = $this->sefRelToAbs("index.php?option=com_content&view=article&id=".$item->info_url);										
			}	
			elseif ($item->other_info_url!=''){
				$item->info_url = $item->other_info_url;
			}
			if(substr($item->demo_url, 0, 4)!='http' && $item->demo_url!=''){
				$item->demo_url = 'http://'.$item->demo_url;
			}	
			if ($item->demo_url!='') {	
				$item->demo_url_title = $paramsSetting->get('open_live');
				$item->demo_url = $this->sefRelToAbs($item->demo_url);							
			}
						
			//thumb detail
			$item->imageThumb = $this->buildThumb($item,  $path_thumbview);											
			
			//params of custom fields
			$item->params = new JParameter($item->datas);	
			
			$themes[$k] = $item;
		}
	
	    jimport('joomla.html.pagination');
		$pagination = new JPagination( $total, $limitstart, $limit );

		$mainframe->addCustomHeadTag ("<link rel=\"stylesheet\" href=\"".JURI::base()."components/com_jashowcase/views/jashowcase/css/ja-showcase.css\" type=\"text/css\" media=\"screen\" />");
		$mainframe->addCustomHeadTag ("<link rel=\"stylesheet\" href='".JURI::base()."components/com_jashowcase/views/jashowcase/css/slimbox.css' type='text/css' media=\"screen\" />");
		define('SHOWCASED', true);
		
		if($params->get('show_cat')){
			$query = "SELECT title, id, alias FROM #__categories WHERE published=1 AND section='com_jashowcase' ORDER BY ordering ASC";
			$db->setQuery($query);
			$categories = $db->loadObjectList();

			$catList = "";
			for($i=0;$i<count($categories);$i++){
					if($catid && $categories[$i]->id == $catid){
						$img = 'document-open.png';
					}
					else{
						$img = 'folder.png';
					}
					$catList .= '<p>';
					if($categories[$i]->alias!=''){
						$categories[$i]->alias = '&catalias='.$categories[$i]->alias;
					}
					$catList .= '<img src="'.JURI::base().'components/com_jashowcase/views/jashowcase/icons/'.$img.'" width="16" height="16" alt="'.$categories[$i]->title.'" /> 
								&nbsp; <a href="'.JRoute::_('index.php?option='.$option.'&view=jashowcase&catid='.$categories[$i]->id, true).'" title="view showcase of '.$categories[$i]->title.' categories">'.$categories[$i]->title.'</a>';
					$catList .= '</p>';
			}
		}
		else{
			$catList = "";
		}
		
		$this->assignRef('categories', $categories);
		$this->assignRef('themes', $themes);
		$this->assignRef('pagination', $pagination);
		$this->assignRef('catList', $catList);
		$this->assignRef('params', $params);
		$this->assignRef('path_thumbview', $path_thumbview);
		$this->assignRef('paramsSetting', $paramsSetting);
		
		parent::display();
	}	
	
	function getPageTitle($pid){
	    $db	=& JFactory::getDBO();
	    $db->setQuery("SELECT `title` from #__content where id = '$pid'");
	    $html = $db->loadResult();
	   	if (!$html) echo $db->getErrorMsg()."<br />".$db->_sql;
	    return $html;
	}
	
	//Get all image in the folder which have same name with image.
	function buildThumb($item, $path_thumbview){	
		global $option;
		
		$ret = '';
		//Remove image extension.
		
			$fulldir = JPATH_SITE.DS . $path_thumbview .DS. $item->directory;
						
			if (is_dir($fulldir) && $item->directory!=''){
				$dh  = opendir($fulldir);
				$regex = '/(\.gif)|(.jpg)|(.png)|(.bmp)$/i';
				$thumb_title = str_replace("[SHOWCASENAME]", $item->name, JText::_('TITLE_SHOWCASE'));
				
				if ($item->thumbnail!='') {
					$img = "<img src='".JURI::base().$path_thumbview ."/$item->directory/$item->thumbnail' border='0'  alt='".$thumb_title."' title=\"".$thumb_title."\" />";					
					while (false !== ($filename = readdir($dh))) {
						if (preg_match($regex, $filename)) {
							$ret .= "<a href=\"".JURI::base().$path_thumbview."/$item->directory/$filename\" rel=\"lightbox[$item->thumbnail]\">$img</a>\n";
							$img = "";
						}
					}		
				}
				else{	
					$i = 0;				
					while (false !== ($filename = readdir($dh))) {
						if ($i==0) {
							$title = $filename;
							$img = "<img src='".JURI::base().$path_thumbview ."/$item->directory/$filename' border='0'  alt='".$thumb_title."' title=\"".$thumb_title."\" />";
						}
						if (preg_match($regex, $filename)) {
							$ret .= "<a href=\"".JURI::base().$path_thumbview."/$item->directory/$filename\" rel=\"lightbox[$title]\">$img</a>\n";
							$img = "";
							$i++;
						}
					}	
					if($i==0){
						$ret .= "<img src='".JURI::base()."components/$option/views/jashowcase/images/default.jpg' border='0' alt='".$item->name."' style=\"padding-bottom:10px\"/><BR/>";
					}
				}					
			}	
			else{
				$ret .= "<img src='".JURI::base()."components/$option/views/jashowcase/images/default.jpg' border='0' alt='".$item->name."' style=\"padding-bottom:10px\"/><BR/>";
			}		
		return $ret;
	}	
	
	/**
	 * return path base
	 * 
	 */
	function sefRelToAbs($value)
	{
		jimport('joomla.application.router');
		// Replace all &amp; with & as the router doesn't understand &amp;
		$url = str_replace('&amp;', '&', $value);
		if(substr(strtolower($url),0,9) != "index.php") return str_replace('&', '&amp;', $url);
		$uri    = JURI::getInstance();
		$prefix = $uri->toString(array('scheme', 'host', 'port'));
		return $prefix.JRoute::_($url);
	}	
}
?>